import { Action } from '@ngrx/store';

export enum UIActionTypes {
  ToggleAcademicYear = '[UI] Toggle Academic Year',
  ExpandAcademicYear = '[UI] Expand Academic Year',
  CollapseAcademicYear = '[UI] Collapse Academic Year',

  OpenCourseSearch = '[UI] Open Course Search',
  CloseCourseSearch = '[UI] Close Course Search',
  ToggleCourseSearch = '[UI] Toggle Course Search',
}

export class ToggleAcademicYear implements Action {
  public readonly type = UIActionTypes.ToggleAcademicYear;
  constructor(public payload: { year: string }) {}
}

export class ExpandAcademicYear implements Action {
  public readonly type = UIActionTypes.ExpandAcademicYear;
  constructor(public payload: { yearCode: string }) {}
}

export class CollapseAcademicYear implements Action {
  public readonly type = UIActionTypes.CollapseAcademicYear;
  constructor(public payload: { yearCode: string }) {}
}

export class OpenCourseSearch implements Action {
  public readonly type = UIActionTypes.OpenCourseSearch;
  constructor() {}
}

export class CloseCourseSearch implements Action {
  public readonly type = UIActionTypes.CloseCourseSearch;
  constructor() {}
}

export class ToggleCourseSearch implements Action {
  public readonly type = UIActionTypes.ToggleCourseSearch;
  constructor() {}
}
